%global debug_package %{nil}
Name: slskd
Version: 0.21.3
Release: 1.git.7.aba387d
License: AGPLv3
Summary: Client-server application for the Soulseek file-sharing network
Url: https://github.com/slskd/slskd
Source0: https://github.com/slskd/slskd/archive/refs/tags/%{version}.tar.gz
Source1: %{name}.sysusers
Source2: %{name}.tmpfiles.conf
Source3: %{name}.service
ExclusiveArch: x86_64 aarch64
BuildRequires: systemd-rpm-macros
BuildRequires: dotnet-host dotnet-sdk-8.0
BuildRequires: nodejs
BuildRequires: nodejs-npm
Requires: dotnet-runtime-8.0
Requires: aspnetcore-runtime-8.0
%{?sysusers_requires_compat}

%description
Client-server application for the Soulseek file-sharing network.

%prep
%autosetup -n %{name}-%{version}

%pre
%sysusers_create_compat %{SOURCE1}

%build
%ifarch x86_64
%global rid linux-x64
%endif
%ifarch aarch64
%global rid linux-arm64
%endif

bin/build --web-only --version %{version}
bin/publish --no-prebuild --runtime %{rid} --version %{version}

%install
%__mkdir_p %{buildroot}%{_datadir}/%{name}
%__mkdir_p %{buildroot}%{_prefix}%{_localstatedir}/%{name}
%__mkdir_p %{buildroot}%{_sysconfdir}/%{name}
%__mkdir_p %{buildroot}%{_bindir}/
%__mkdir %{buildroot}%{_prefix}%{_localstatedir}/%{name}/config

cd dist/%{rid}/
%__install -Dm 0755 %{name} %{buildroot}%{_bindir}/
%__cp -r wwwroot %{buildroot}%{_datadir}/%{name}/
%__install -Dm 0644 config/%{name}.example.yml %{buildroot}/%{_prefix}%{_localstatedir}/%{name}/config/

%global sedn -e 's:$NAME:%{name}:g'
%global sedd -e 's:$DATADIR:%{_datadir}:g'
%global sedl -e 's:$LOCALSTATEDIR:%{_prefix}%{_localstatedir}:g'
%global seds -e 's:$SYSCONFDIR:%{_sysconfdir}:g'

%__sed %{sedn} %{sedl} %{SOURCE1} > %{SOURCE1}.n && %__mv %{SOURCE1}.n %{SOURCE1}
%__install -Dm 0644 %{SOURCE1} %{buildroot}%{_sysusersdir}/%{name}.conf

%__sed %{sedn} %{sedl} %{sedd} %{seds} %{SOURCE2} > %{SOURCE2}.n && %__mv %{SOURCE2}.n %{SOURCE2}
%__install -Dm 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf

%__sed %{sedn} %{seds} %{sedl} %{sedd} %{SOURCE3} > %{SOURCE3}.n && %__mv %{SOURCE3}.n %{SOURCE3}
%__install -Dm 0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service

%post
%systemd_post %{name}.service
%tmpfiles_create %{_tmpfilesdir}/%{name}.conf

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service
userdel %{name}
%__rm -r %{_datadir}/%{name}
%__rm -r %{_prefix}%{_localstatedir}/%{name}

%files
%{_sysusersdir}/%{name}.conf
%{_tmpfilesdir}/%{name}.conf
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/%{name}
%{_datadir}/%{name}
%{_prefix}%{_localstatedir}/%{name}
%{_bindir}/%{name}

%changelog
* Mon Sep 02 2024 hiddengem <hiddengem2@protonmail.com> 0.21.3-1
- new package built with tito

